<?php
namespace Drupal\nested_permission\EventSubscriber;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpKernel\Event\GetResponseEvent;
use Symfony\Component\HttpKernel\KernelEvents;
use Drupal\Core\Url;
/**
 * Redirect .html pages to corresponding Node page.
 */
class CustomredirectSubscriber implements EventSubscriberInterface {

    /** @var int */
    private $redirectCode = 301;

    /**
     * Redirect pattern based url
     * @param GetResponseEvent $event
     */
    public function customRedirection(GetResponseEvent $event) {


        $requestUrl = \Drupal::service('path.current')->getPath();
       /**
         * Here i am redirecting the /admin/people/roles to respective /admin/people/role.
         */
         $strRequestUrl = strval($requestUrl);
        if ($strRequestUrl =='/admin/people/roles') {

            $response = new RedirectResponse(Url::fromRoute('nested_roles.nested_roles_form')->toString());
            $response->send();
            exit(0);
        }
    }

    /**
     * Listen to kernel.request events and call customRedirection.
     * {@inheritdoc}
     * @return array Event names to listen to (key) and methods to call (value)
     */
    public static function getSubscribedEvents() {
        $events[KernelEvents::REQUEST][] = array('customRedirection');
        return $events;
    }
}